#include <stdio.h>
#include <stdlib.h>
#include "fnxrand_v2.c"
#define mazeroutines_SVAL 16
#define mazeroutines_FVAL 7

struct Maze {
 char **maze;
 int MAZEMAX;
 int sizelimit;
};

struct Maze* CreateMaze(int maximum_possible_width_height);
void PrepareMaze(struct Maze *m,int mazesize);
void PROCdisplay(struct Maze *m);
void PROCok(struct Maze *m);
void PROChackfix(struct Maze *m);
int sgn(int inp);
void PROCwalls(struct Maze *m);
void PROCclean(struct Maze *m);
void PROCfillclean(struct Maze *m);
int FNfloodfill(int x,int y,struct Maze *m);

int RUBISHmain(int argc, char **argv){
 int s;
 if( argc>1 )
  s = atoi(argv[1]);
 else
  s = 50;
 struct Maze *test = CreateMaze(s);
 PrepareMaze(test,s);
 return 0;
}

struct Maze* CreateMaze(int maximum_possible_width_height){ 
 struct Maze *out = calloc(1, sizeof(struct Maze));
 char **maze;
 int i;
 maze=malloc(sizeof(char*)*maximum_possible_width_height);
 for(i=0;i<maximum_possible_width_height;i++){
  maze[i]=malloc(sizeof(char)*maximum_possible_width_height);
 }
 out->maze=maze;
 out->sizelimit=maximum_possible_width_height;
 return out;
}

void PrepareMaze(struct Maze *m,int mazesize){
 //printf("makemaze\n");
 char **maze = m->maze;
 int MAZEMAX=(mazesize-(mazesize % 2))-1;
 m->MAZEMAX=MAZEMAX;

 do{
  PROCclean(m);
  PROCok(m);
  PROCwalls(m);
  PROChackfix(m);
  PROCwalls(m);
  maze[1][0]=0;
  maze[MAZEMAX-2][MAZEMAX-1]=0;
  //PROCdisplay(m);
 }while(!FNfloodfill(1,0,m));
 PROCfillclean(m);
 PROCdisplay(m);

 //m->maze = maze;
}

void PROCdisplay(struct Maze *m){
 //printf("display\n");
 char **maze = m->maze;
 int MAZEMAX = m->MAZEMAX;
 int i,j; 

 for(i=0;i<=MAZEMAX-1;i+=1){
  for(j=0;j<=MAZEMAX-1;j+=1){
   printf("%c",maze[j][i]+32);
  }
  printf("\n");
 }

}

void PROCok(struct Maze *m){
 //printf("\n");
 char **maze = m->maze;
 int MAZEMAX = m->MAZEMAX;
 int i,j;
 for(i=0;i<=MAZEMAX-2;i+=2){
  for(j=0;j<=MAZEMAX-2;j+=2){
   maze[i  ][j  ]=mazeroutines_SVAL;
   maze[i+1][j  ]=0;

   maze[i+1][j+1]=0;
   maze[i+1][j+1]=0;
  }
 }
}

void PROChackfix(struct Maze *m){
 //printf("hackfix\n");
 char **maze = m->maze;
 int MAZEMAX = m->MAZEMAX;
 int i,j,nochanges,chance_a,chance_b;
 chance_a=80;
 chance_b=150;
 do{
  nochanges=1;
  for(i=1;i<=MAZEMAX-2;i+=1){
   for(j=1;j<=MAZEMAX-2;j+=1){
    if(maze[i][j]==mazeroutines_SVAL){
   
     if( maze[i-1][j-1]==0 && maze[i][j-1]==0 && maze[i+1][j-1]==0    && maze[i-1][j]==0 && maze[i+1][j]==0    && maze[i-1][j+1]==0 && maze[i][j+1]==0 && maze[i+1][j+1]==0 ){
      if(FNxrand(100)>chance_a){
       if(FNxrand(2)) { maze[i+sgn(FNxrand(200)-100)][j]=mazeroutines_SVAL; }else{ maze[i][j+sgn(FNxrand(200)-100)]=mazeroutines_SVAL; }
      }else{
       maze[i+sgn(FNxrand(200)-100)][j]=mazeroutines_SVAL;
       maze[i][j+sgn(FNxrand(200)-100)]=mazeroutines_SVAL;
      }
      nochanges=0;
     }
     
    }
    if(maze[i][j]==0){

     if( maze[i-1][j-1]==mazeroutines_SVAL && maze[i][j-1]==mazeroutines_SVAL && maze[i+1][j-1]==mazeroutines_SVAL    && maze[i-1][j]==mazeroutines_SVAL && maze[i+1][j]==mazeroutines_SVAL    && maze[i-1][j+1]==mazeroutines_SVAL && maze[i][j+1]==mazeroutines_SVAL && maze[i+1][j+1]==mazeroutines_SVAL ){
      if(FNxrand(100)>chance_a){
       if(FNxrand(2)) { maze[i+sgn(FNxrand(200)-100)][j]=0; }else{ maze[i][j+sgn(FNxrand(200)-100)]=0; }
      }else{
       maze[i+sgn(FNxrand(200)-100)][j]=0;
       maze[i][j+sgn(FNxrand(200)-100)]=0;
      }
      nochanges=0;
     }
     
    }
   }
  }
 }while(!nochanges);
}

int sgn(int inp){
 //printf("sgn\n");
 if (inp>0) return 1;
 if (inp<0) return -1;
 return 0;
}

void PROCwalls(struct Maze *m){
 //printf("walls\n");
 char **maze = m->maze;
 int MAZEMAX = m->MAZEMAX;
 int i;
 for(i=1;i<=MAZEMAX-1;i+=1){
  maze[i][0        ]=mazeroutines_SVAL;
  maze[i][MAZEMAX-1]=mazeroutines_SVAL;
 }
 for(i=1;i<=MAZEMAX-1;i+=1){
  maze[0        ][i]=mazeroutines_SVAL;
  maze[MAZEMAX-1][i]=mazeroutines_SVAL;
 }
}

void PROCclean(struct Maze *m){
 //printf("clean\n");
 char **maze = m->maze;
 int MAZEMAX = m->MAZEMAX;
 int i,j;
 for(i=0;i<=MAZEMAX-1;i+=1){
  for(j=0;j<=MAZEMAX-1;j+=1){
   maze[j][i]=0;
  }
 }
}
void PROCfillclean(struct Maze *m){
 //printf("fillclean\n");
 char **maze = m->maze;
 int MAZEMAX = m->MAZEMAX;
 int i,j;
 for(i=0;i<=MAZEMAX-1;i+=1){
  for(j=0;j<=MAZEMAX-1;j+=1){
   if(maze[j][i]==mazeroutines_FVAL) maze[j][i]=0;
  }
 }
}

int FNfloodfill(int x,int y,struct Maze *m){
 //printf("floodfill %d %d\n",x,y);
 char **maze = m->maze;
 int MAZEMAX = m->MAZEMAX;
 if(x<0 || y<0 || x>(MAZEMAX-1) || y>(MAZEMAX-1)) return 0;
 if (maze[x][y] != 0) return 0;
 maze[x][y]=mazeroutines_FVAL;
 if( x==(MAZEMAX-2) && y==(MAZEMAX-1) ) return 1;
 int result=0; 
 result=result | FNfloodfill(x-1,y  ,m);
 result=result | FNfloodfill(x  ,y-1,m);
 result=result | FNfloodfill(x+1,y  ,m);
 result=result | FNfloodfill(x  ,y+1,m);
 return result;
}